# Generated by the Protocol Buffers compiler. DO NOT EDIT!
# source: l2smmd.proto
# plugin: grpclib.plugin.main
import abc
import typing

import grpclib.const
import grpclib.client
if typing.TYPE_CHECKING:
    import grpclib.server

from . import l2smmd_pb2


class L2SMMultiDomainServiceBase(abc.ABC):

    @abc.abstractmethod
    async def CreateNetwork(self, stream: 'grpclib.server.Stream[l2smmd_pb2.CreateNetworkRequest, l2smmd_pb2.CreateNetworkResponse]') -> None:
        pass

    @abc.abstractmethod
    async def DeleteNetwork(self, stream: 'grpclib.server.Stream[l2smmd_pb2.DeleteNetworkRequest, l2smmd_pb2.DeleteNetworkResponse]') -> None:
        pass

    @abc.abstractmethod
    async def CreateSlice(self, stream: 'grpclib.server.Stream[l2smmd_pb2.CreateSliceRequest, l2smmd_pb2.CreateSliceResponse]') -> None:
        pass

    @abc.abstractmethod
    async def CreateOverlay(self, stream: 'grpclib.server.Stream[l2smmd_pb2.CreateOverlayRequest, l2smmd_pb2.CreateOverlayResponse]') -> None:
        pass

    @abc.abstractmethod
    async def AddCluster(self, stream: 'grpclib.server.Stream[l2smmd_pb2.AddClusterRequest, l2smmd_pb2.AddClusterResponse]') -> None:
        pass

    @abc.abstractmethod
    async def RemoveCluster(self, stream: 'grpclib.server.Stream[l2smmd_pb2.RemoveClusterRequest, l2smmd_pb2.RemoveClusterResponse]') -> None:
        pass

    @abc.abstractmethod
    async def DeleteOverlay(self, stream: 'grpclib.server.Stream[l2smmd_pb2.DeleteOverlayRequest, l2smmd_pb2.DeleteOverlayResponse]') -> None:
        pass

    def __mapping__(self) -> typing.Dict[str, grpclib.const.Handler]:
        return {
            '/l2smmd.L2SMMultiDomainService/CreateNetwork': grpclib.const.Handler(
                self.CreateNetwork,
                grpclib.const.Cardinality.UNARY_UNARY,
                l2smmd_pb2.CreateNetworkRequest,
                l2smmd_pb2.CreateNetworkResponse,
            ),
            '/l2smmd.L2SMMultiDomainService/DeleteNetwork': grpclib.const.Handler(
                self.DeleteNetwork,
                grpclib.const.Cardinality.UNARY_UNARY,
                l2smmd_pb2.DeleteNetworkRequest,
                l2smmd_pb2.DeleteNetworkResponse,
            ),
            '/l2smmd.L2SMMultiDomainService/CreateSlice': grpclib.const.Handler(
                self.CreateSlice,
                grpclib.const.Cardinality.UNARY_UNARY,
                l2smmd_pb2.CreateSliceRequest,
                l2smmd_pb2.CreateSliceResponse,
            ),
            '/l2smmd.L2SMMultiDomainService/CreateOverlay': grpclib.const.Handler(
                self.CreateOverlay,
                grpclib.const.Cardinality.UNARY_UNARY,
                l2smmd_pb2.CreateOverlayRequest,
                l2smmd_pb2.CreateOverlayResponse,
            ),
            '/l2smmd.L2SMMultiDomainService/AddCluster': grpclib.const.Handler(
                self.AddCluster,
                grpclib.const.Cardinality.UNARY_UNARY,
                l2smmd_pb2.AddClusterRequest,
                l2smmd_pb2.AddClusterResponse,
            ),
            '/l2smmd.L2SMMultiDomainService/RemoveCluster': grpclib.const.Handler(
                self.RemoveCluster,
                grpclib.const.Cardinality.UNARY_UNARY,
                l2smmd_pb2.RemoveClusterRequest,
                l2smmd_pb2.RemoveClusterResponse,
            ),
            '/l2smmd.L2SMMultiDomainService/DeleteOverlay': grpclib.const.Handler(
                self.DeleteOverlay,
                grpclib.const.Cardinality.UNARY_UNARY,
                l2smmd_pb2.DeleteOverlayRequest,
                l2smmd_pb2.DeleteOverlayResponse,
            ),
        }


class L2SMMultiDomainServiceStub:

    def __init__(self, channel: grpclib.client.Channel) -> None:
        self.CreateNetwork = grpclib.client.UnaryUnaryMethod(
            channel,
            '/l2smmd.L2SMMultiDomainService/CreateNetwork',
            l2smmd_pb2.CreateNetworkRequest,
            l2smmd_pb2.CreateNetworkResponse,
        )
        self.DeleteNetwork = grpclib.client.UnaryUnaryMethod(
            channel,
            '/l2smmd.L2SMMultiDomainService/DeleteNetwork',
            l2smmd_pb2.DeleteNetworkRequest,
            l2smmd_pb2.DeleteNetworkResponse,
        )
        self.CreateSlice = grpclib.client.UnaryUnaryMethod(
            channel,
            '/l2smmd.L2SMMultiDomainService/CreateSlice',
            l2smmd_pb2.CreateSliceRequest,
            l2smmd_pb2.CreateSliceResponse,
        )
        self.CreateOverlay = grpclib.client.UnaryUnaryMethod(
            channel,
            '/l2smmd.L2SMMultiDomainService/CreateOverlay',
            l2smmd_pb2.CreateOverlayRequest,
            l2smmd_pb2.CreateOverlayResponse,
        )
        self.AddCluster = grpclib.client.UnaryUnaryMethod(
            channel,
            '/l2smmd.L2SMMultiDomainService/AddCluster',
            l2smmd_pb2.AddClusterRequest,
            l2smmd_pb2.AddClusterResponse,
        )
        self.RemoveCluster = grpclib.client.UnaryUnaryMethod(
            channel,
            '/l2smmd.L2SMMultiDomainService/RemoveCluster',
            l2smmd_pb2.RemoveClusterRequest,
            l2smmd_pb2.RemoveClusterResponse,
        )
        self.DeleteOverlay = grpclib.client.UnaryUnaryMethod(
            channel,
            '/l2smmd.L2SMMultiDomainService/DeleteOverlay',
            l2smmd_pb2.DeleteOverlayRequest,
            l2smmd_pb2.DeleteOverlayResponse,
        )
